#include "q0.h"

#include <iostream>
#include <new>

using namespace std ;


static TreeNode* makeTree( int label, TreeNode *left, TreeNode *right, bool &ok ) {
	if( ok ) {
		TreeNode *t = new(nothrow) TreeNode ;
		if( t==0 ) { ok = false ; return 0; }
		t->label = label ;
		t->left = left ;
		t->right = right ;
	    return t ; }
	else {
		return 0 ; }
}

template<class T>
bool eqLists( const List<T> &x, const List<T> &y ) {
	cout << "Checking lengths" << endl ;
	cout << x.length() << "==" <<  y.length() << endl ;
	if( x.length() != y.length() ) return false ;
	cout << "Lengths equal" << endl ;
	for( int i=0 ; i < x.length() ; ++i ) {
		cout << "Checking item " << i << endl ;
		cout << x.retrieve(i) << "==" <<  y.retrieve(i) << endl ;
		if( x.retrieve(i) != y.retrieve(i) ) return false ; }
	return true ;
}

int testCount() { return 2 ; }

// doTest  --- do one test //
/////////////////////////////
void doTest( int testNumber, int &result ) {
    bool pass = false ;
    try {
        cout << "Test " << testNumber << "\n" ;
        switch( testNumber ) {
        case 0 : {
			List<int> result ;
			List<int> expected ;
			flattenTree( 0, result ) ;
			pass = eqLists( result, expected )  ;
		} break ;
        case 1 : {
			bool ok = true ;
			TreeNode *t = makeTree( 4,
				            makeTree( 2,
							   makeTree( 0, 0, 0, ok ),
			                   makeTree( 1, 0, 0, ok ),
						       ok ),
						    makeTree( 5,
						       0,
							   makeTree( 7,
							      0,
								  makeTree( 9,
								     0,
								     makeTree( 11, 0, 0, ok ),
								     ok ),
								  ok ),
							   ok),
						    ok ) ;

			List<int> result ;
			List<int> expected ;
			expected.insert(0, 0 ) ;
			expected.insert(1, 2 ) ;
			expected.insert(2, 1 ) ;
			expected.insert(3, 4 ) ;
			expected.insert(4, 5 ) ;
			expected.insert(5, 7 ) ;
			expected.insert(6, 9 ) ;
			expected.insert(7, 11 ) ;
			flattenTree( t, result ) ;
			pass = eqLists( result, expected )  ;
		} break ;
        default : pass = false ;
        } }
    catch( ... ) {
        cerr << "Sorry an unanticipated exception occurred\n" ;
        pass = false ; }
	

    if( pass ) {
        cout << "Test " << testNumber << " passes\n" ;
        result = 0 ; }
    else {
        cout << "Test " << testNumber << " fails\n" ;
        result = 1 ; }
}