/* Test jig for the querytree class.
*/

#include "q2.h" 

#include <cstdlib>
#include <ctime>
#include <iostream>  // Standard I/O

using namespace std ;

// testCount --- the number of tests //
///////////////////////////////////////
int testCount() { return 4 ; }

// doTest  --- do one test //
/////////////////////////////
void doTest( int testNumber, int &result ) {
    try {
        bool pass = true ;
		{
        cout << "Test " << testNumber << "\n" ;

        
        switch( testNumber ) {

        case 0 : {     
            Set<int> A ;
			Set<int> B ;
			Set<int> C ;
			Set<int> Expected ;
			setSubtraction( A, B, C ) ;
			pass = C == Expected ;
        } break ;
 
        case 1 : {     
            Set<int> A ;
			Set<int> B ;
			Set<int> C ;
			Set<int> Expected ;
			A.insert(22) ;
			Expected.insert( 22 ) ;
			A.insert( 99 ) ;
			Expected.insert( 99 ) ;
			A.insert( 15 ) ;
			Expected.insert( 15 ) ;

			setSubtraction( A, B, C ) ;
			pass = C == Expected ;
        } break ;

        case 2 : {     
            Set<int> A ;
			Set<int> B ;
			Set<int> C ;
			Set<int> Expected ;
			B.insert(22) ;
			B.insert( 99 ) ;
			B.insert( 15 ) ;

			setSubtraction( A, B, C ) ;
			pass = C == Expected ;
        } break ;

        case 3 : {    
            Set<int> A ;
			Set<int> B ;
			Set<int> C ;
			Set<int> Expected ;
			A.insert(22) ;
			B.insert(22) ;
			B.insert( 99 ) ;
			A.insert( 15 ) ;
			Expected.insert( 15 ) ;
			B.insert( 7 ) ;
			A.insert( 6 ) ;
			Expected.insert( 6 ) ;

			setSubtraction( A, B, C ) ;
			pass = C == Expected ;
        } break ;

        case 4 : {   
            Set<char*> A ;
			Set<char*> B ;
			Set<char*> C ;
			Set<char*> Expected ;
			setSubtraction( A, B, C ) ;
			pass = C == Expected ;
        } break ;

       default : pass = false ;
        } 
		}  // Destructors called here.
        if( pass ) {
            cout << "Test " << testNumber << " passes\n" ;
            result = 0 ; }
        else {
            cout << "Test " << testNumber << " fails\n" ;
            result = 1 ; } }
    catch( ... ) {
        cerr << "Sorry an unanticipated exception occurred\n" ;
        result = 1 ; } }